=== debian/changelog ===
mgba (0.10.2+dfsg-1.1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:06:35 +0000

mgba (0.10.2+dfsg-1.1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:55:31 +0000

mgba (0.10.2+dfsg-1.1build1) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 01:02:32 +0000

mgba (0.10.2+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062872

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 20:00:04 +0000

mgba (0.10.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - fixed broken audio in libretro core (Closes: #1036829)

 -- Ryan Tandy <ryan@nardis.ca>  Sat, 17 Jun 2023 11:32:25 -0700
