## mgba 0.10.3+dfsg

=== debian/changelog ===
mgba (0.10.3+dfsg-2build2) plucky; urgency=medium

  * Rebuild against latest libzip

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 22 Nov 2024 08:54:47 -0500

mgba (0.10.3+dfsg-2build1) oracular; urgency=medium

  * Rebuild against new libavcodec61.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 31 Jul 2024 17:17:46 +0200

mgba (0.10.3+dfsg-2) unstable; urgency=medium

  * Import upstream patch to fix FTBFS with GCC 14. (Closes: #1075267)

 -- Ryan Tandy <ryan@nardis.ca>  Sat, 27 Jul 2024 11:48:18 -0700

mgba (0.10.3+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - added support for FFmpeg 7.0 (Closes: #1072434)
  * Exclude headers related to foreign threading platforms, which cannot be
    included on Debian, from libmgba-dev. See #1062872.
  * debian/gitlab-ci.yml: Update to salsa-ci pipeline.
  * debian/watch: Update to version 4 and use GitHub releases API.
  * Update Standards-Version to 4.6.2. No changes needed.
  * Update Build-Depends: pkg-config to pkgconf.

 -- Ryan Tandy <ryan@nardis.ca>  Fri, 08 Mar 2024 18:41:50 -0800
