=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: mgba
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>, Ryan Tandy <ryan@nardis.ca>
-Build-Depends: dpkg-dev (>= 1.22.5), cmake (>= 3.1),
+Build-Depends: cmake (>= 3.1),
                debhelper-compat (= 13),
                desktop-file-utils,
+               dpkg-dev (>= 1.22.5),
                libavcodec-dev,
                libavfilter-dev,
                libavformat-dev,
@@ -23,7 +23,7 @@
                libswresample-dev,
                libswscale-dev,
                libzip-dev,
-               pkg-config,
+               pkgconf,
                qtbase5-dev,
                qtmultimedia5-dev,
                qttools5-dev-tools,
@@ -32,7 +32,7 @@
                zipmerge,
                ziptool,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://mgba.io/
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/games-team/mgba.git
