## mgba 0.10.4+dfsg

=== debian/changelog ===
mgba (0.10.4+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Drop GCC 14 patch, applied upstream.
  * Update Standards-Version to 4.7.0. No changes needed.
  * Fix/improve AppStream metadata files:
    - debian/io.mgba.libretro-mgba.metainfo.xml:
      + Change the component ID to rDNS format. Fixes an appstreamcli
        validation warning (cid-is-not-rdns).
      + Rename libretro-mgba.metainfo.xml to follow the cID change.
      + Update retroarch's component ID in <extends>.
    - debian/io.mgba.mGBA.appdata.xml:
      + Rename mgba-qt.appdata.xml to match the component ID. Fixes an
        appstreamcli validation warning (metainfo-filename-cid-mismatch).
      + Add launchable tag. Fixes an appstreamcli validation info
        (desktop-app-launchable-omitted).

 -- Ryan Tandy <ryan@nardis.ca>  Mon, 23 Dec 2024 17:10:53 -0800
