=== debian/control ===
--- 
+++ 
@@ -32,7 +32,7 @@
                zipmerge,
                ziptool,
                zlib1g-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://mgba.io/
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/games-team/mgba.git
