## mgba 0.10.5%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: mgba
 Section: games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>, Ryan Tandy <ryan@nardis.ca>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Uploaders: Ryan Tandy <ryan@nardis.ca>
 Build-Depends: cmake (>= 3.1),
                debhelper-compat (= 13),
                desktop-file-utils,
@@ -32,9 +33,8 @@
                zipmerge,
                ziptool,
                zlib1g-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://mgba.io/
-Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/games-team/mgba.git
 Vcs-Browser: https://salsa.debian.org/games-team/mgba
 
@@ -102,6 +102,7 @@
 
 Package: mgba-common
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Suggests: mgba-qt
 Description: Game Boy Advance emulator (common files for mGBA)
